﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DelegateTest
{
    class Program
    {
        public delegate void MyDelegate1(); //Declare the delegate MyDelegate1 - signature: { "Method name": MyDelegate1, "parameterlist" : (), "return-type": void}

        public delegate bool MyDelegate2(int value); //Declare the delegate MyDelegate2 - signature:{ "Method name": MyDelegate2,  "parameterlist": (int), "return-type": bool}
   

        static void Main(string[] args)
        {
            MyDelegate1 myDelegate1 = new MyDelegate1(CallBack1); //associate the delegate myDelegate1 with the method CallBack1()
            myDelegate1();                                        //Invoke the method CallBack1 through the delegate myDelegate1

            MyDelegate2 myDelegate2 = CallBack2;                  //Implicit instantiation of the delegate, just assign the reference to the method
            myDelegate2(2);

            myDelegate2 = CallBack3;                              //Assigns the delegate myDelegate2 to a new method CallBack3 (with the same signature)
            myDelegate2(3);


            myDelegate2 = delegate                                //Assigns the delegate myDelegate2 to a new anonymous method
            {
                Console.WriteLine("Calling an anonymous method");
                return true;
            };
            myDelegate2(4);
        }

        static void CallBack1()    //CallBack funktion - method to be associatet to and invoked by the delegate
        {
            Console.WriteLine("Calling CallBack1");
        }

        static bool CallBack2(int value)
        {
            Console.WriteLine("Calling CallBack2, value: " + value);
            return true;
        }

        static bool CallBack3(int value)
        {
             Console.WriteLine("Calling CallBack3, value: " + value);
            return true;
        }

    }
}
